/*
 * This file is provided for unrestricted use
 * provided that this legend is included on all tape media
 * and as a part of the software program in whole or part.  Users
 * may copy or modify this file without charge, but are not authorized to
 * license or distribute it to anyone else except as part of a product
 * or program developed by the user.
 *
 * THIS FILE IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
 * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 *
 * This file is provided with no support and without any obligation on the
 * part of Resumix, Inc. to assist in its use, correction,
 * modification or enhancement.
 *
 * Resumix, Inc. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY THIS FILE
 * OR ANY PART THEREOF.
 *
 * In no event will Resumix, Inc. be liable for any lost revenue
 * or profits or other special, indirect and consequential damages, even
 * if Resumix has been advised of the possibility of such damages.
 *
 * Resumix, Inc.
 */

#ifndef XVNEWS_CONFIG_H
#define XVNEWS_CONFIG_H

/* This file contains the configurable options of xvnews, please make
   the changes needed below.
 */

/* Sets the default company name. Can be overridden by setting $ORGANIZATION */
#define ORGANIZATION    "The Unconfigured xvnews people"

/* The default NNTP server to connect to. Can be overridden by setting $NNTPSERVER */
#define NNTPSERVER	"news"

/* The domain to use. Sets everything after the @ sign for postings. Can be
   overridden by setting $DOMAIN.
 */
#define DOMAIN 		"xvnews.unconfigured.domain"

/* The host to put in headers for the Path line.
 */
#define PATH_HOST	""

/* Some sites that use CNEWS don't want to show the user news groups that
 *  have the status 'x' or '=' as these groups are really not available.
 */
#define CNEWS_DONT_SHOW 1

/* ADD_SIGNATURE defines whether a signature should be added
   One reason not to add a signature is if this is also done
   by another part of the news system, e.g. if you are posting
   through inews
*/
#define ADD_SIGNATURE 1

/* USE_INEWS_TO_POST defines whether inews is used to post.
   Normally you would post through xvnews directly, but certain
   characteristics of your news system (such as security measures)
   might require you to post through a version of inews.
   INEWS_PROGRAM indicates the inews program to use. Some people have
   noted problems using NNTP's inews while running B News. If you have
   posting problems you might look into this.
*/
#undef USE_INEWS_TO_POST
#define INEWS_PROGRAM "inews -h"

/* MAIL_PROGRAM is the program used to deliver mail messages.
   /usr/lib/sendmail -t is a good choice, and should work on most systems
*/
#define MAIL_PROGRAM "/usr/lib/sendmail -t"

/* COMPRESS_PROGRAM is the program which compresses your files,
   usually this will be compress. On SunOS 4.x, use /usr/ucb/compress,
   on SunOS 5.x, use /usr/bin/compress. You could also use gzip, but
   then you should also change the extension below to "gz".
   */
#define COMPRESS_PROGRAM "compress"
#define COMPRESS_EXTENSION "Z"

/* The following two defines set the initial number of articles in a
   newsgroup and the initial number of newsgroups. Xvnews will update
   these numbers if there are more articles or newsgroups, which means
   you *could* define both numbers to be 1. However, for performance
   reasons you will want to allocate some space upfront. You should set
   these numbers to something a bit above your average situation.
*/   

#define INIT_NUM_ARTICLES 256
#define INIT_NUM_GROUPS 2048

#endif /* XVNEWS_CONFIG_H */
