/*
 * This file is provided for unrestricted use
 * provided that this legend is included on all tape media
 * and as a part of the software program in whole or part.  Users
 * may copy or modify this file without charge, but are not authorized to
 * license or distribute it to anyone else except as part of a product
 * or program developed by the user.
 *
 * THIS FILE IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
 * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 *
 * This file is provided with no support and without any obligation on the
 * part of Sun Microsystems, Inc. to assist in its use, correction,
 * modification or enhancement.
 *
 * SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY THIS FILE
 * OR ANY PART THEREOF.
 *
 * In no event will Sun Microsystems, Inc. be liable for any lost revenue
 * or profits or other special, indirect and consequential damages, even
 * if Sun has been advised of the possibility of such damages.
 *
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */

#include <X11/Xos.h>
#include <stdio.h>
#include <sys/stat.h>
#include <xview/xview.h>
#include <xview/panel.h>

#include "xvnews_ui.h"
#include "xvnews.h"

void sortSubjects(ip, flg)
     xvnews_xvnews_window_objects *ip;
     int flg;
{
   static char **list;
   static s_node **sort_list;
   static l_max = 0;
   char	*old;
   int	i=0, nrows, nrow = xv_get(ip->articles_list, PANEL_LIST_NROWS);
   int	top, seek;
   s_node *temp = NULL;
   
   if (nrow == 1)
      return;

/* Initialize the static lists etc. Leif Hedstrom believes the '+1' is
   needed for the sorting algorithm. He didn't dare to change it, and it's
   only one field andway */
   if (l_max <= nrow) 
   {
      if (!l_max) 
      {
	 list = (char **)malloc((nrow + 1) * sizeof(char *));
	 sort_list = (s_node **)malloc((nrow + 1) * sizeof(s_node *));
      }
      else 
      {
	 list = (char **)realloc(list, (nrow + 1) * sizeof(char *));
	 sort_list = (s_node **)realloc(sort_list, (nrow + 1) *
					sizeof(s_node *));
      }
      memset(&(list[l_max]), '\0', (nrow - l_max + 1) * sizeof(char *));
      memset(&(sort_list[l_max]), '\0', (nrow - l_max + 1) * sizeof(s_node *));
      l_max = nrow + 1;
   }
   
   nrows = nrow;
   while (nrow) {
      old = (char *)xv_get(ip->articles_list, PANEL_LIST_STRING, --nrow);
      createSortList(sort_list, old, flg, i++);
   }	
   if (sort_list[i]) 
   {
      free(sort_list[i]->string);
      free(sort_list[i]);
   }
   sort_list[i] = NULL;

   for (top = 0; top < nrows - 1; top++)
      for (seek = top + 1; seek < nrows; seek++)
	 if (compareFields(sort_list[seek], sort_list[top])) {
	    temp = sort_list[top];
	    sort_list[top] = sort_list[seek];
	    sort_list[seek] = temp;
	 }

   loadList(list, sort_list);

   if (flg == 2) 
      xv_set(ip->articles_list, XV_SHOW, FALSE, NULL);

   xv_set(ip->articles_list, PANEL_LIST_DELETE_ROWS, 0, nrows, NULL);
   xv_set(ip->articles_list, PANEL_LIST_INSERT_STRINGS, 0, list, NULL);

}

loadList(list, sort_list)
     char *list[];
     s_node *sort_list[];
{
   int i = 0;

   while (sort_list[i] != NULL) {
      list[i] = (sort_list[i])->string;
      i++;
   }
   
   if (sort_list[i]) 
   {
      free(sort_list[i]->string);
      free(sort_list[i]);
   }
   list[i] = NULL;
}

createSortList(sort_list, old, flg, i)
     s_node *sort_list[];
     char *old;
     int flg, i;
{
   s_node *new;
   char	*getSubject();

   if (!sort_list[i]) 
   {
      sort_list[i] = (s_node *)malloc(sizeof(s_node));
      sort_list[i]->string = (char *)malloc(SUBJECT_LENGTH + AUTHOR_LENGTH + 20);
   }
   strcpy(sort_list[i]->string, old);
   sort_list[i]->len = SUBJECT_LENGTH;
   sort_list[i]->subject = flg ? sort_list[i]->string :
      getSubject(sort_list[i]->string, &(sort_list[i]->len));
}

char *
getSubject(string, i)
     char *string;
     int *i;
{
   char *c = string;

   while (!isalpha(*c))
      c++, (*i)--;
   if (!strncasecmp(c, "re:", 3)) {
      c += 3, (*i) -= 3;
      while (!isalpha(*c) && *i)
	 c++, (*i)--;
   }
   
   return c;
}

int compareFields(a, b)
     s_node *a, *b;
{
   int res;

   res = strncasecmp(a->subject, b->subject, a->len < b->len ? a->len:b->len);

   return((res <= 0 ) ? 1 : 0);
}
